// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: braces fieldsfirst space lnc 

package com.olio.bluetooth.profiles.gatt;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothGattDescriptor;
import android.bluetooth.BluetoothGattService;
import android.content.Context;
import android.os.Handler;
import com.olio.bluetooth.ble.promise.BleClient;
import com.olio.bluetooth.ble.promise.BleDeferredException;
import com.olio.bluetooth.ble.promise.communication.BleRequestManager;
import com.olio.bluetooth.ble.promise.framework.PromiseException;
import com.olio.bluetooth.ble.promise.framework.SingleActionObject;
import com.olio.bluetooth.ble.promise.power.PowerCycle;
import com.olio.bluetooth.ble.promise.server.ReceiveWriteRequests;
import com.olio.communication.messages.Message;
import com.olio.communication.messages.MessageBuilder;
import com.olio.communication.notifications.new_notifications.StreamItemBuilder;
import com.olio.data.object.bluetooth_status.BluetoothStatus;
import com.olio.server.RequestManager;
import com.olio.util.ALog;
import com.olio.util.RecoveryTimer;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;
import org.jdeferred.AlwaysCallback;
import org.jdeferred.Deferred;
import org.jdeferred.DoneCallback;
import org.jdeferred.DonePipe;
import org.jdeferred.FailCallback;
import org.jdeferred.ProgressCallback;
import org.jdeferred.Promise;

public class GattClientConnection extends SingleActionObject
{
    public static class GattClientUpdate
    {

        public Message object;
        public Status status;

        public GattClientUpdate(Status status1, Message message)
        {
            status = status1;
            object = message;
        }
    }

    public static final class Status extends Enum
    {

        private static final Status $VALUES[];
        public static final Status CONNECTED;
        public static final Status CONNECTING;
        public static final Status MESSAGE_RECEIVED;
        public static final Status NOT_CONNECTED;

        public static Status valueOf(String s)
        {
            return (Status)Enum.valueOf(com/olio/bluetooth/profiles/gatt/GattClientConnection$Status, s);
        }

        public static Status[] values()
        {
            return (Status[])$VALUES.clone();
        }

        static 
        {
            NOT_CONNECTED = new Status("NOT_CONNECTED", 0);
            CONNECTING = new Status("CONNECTING", 1);
            CONNECTED = new Status("CONNECTED", 2);
            MESSAGE_RECEIVED = new Status("MESSAGE_RECEIVED", 3);
            $VALUES = (new Status[] {
                NOT_CONNECTED, CONNECTING, CONNECTED, MESSAGE_RECEIVED
            });
        }

        private Status(String s, int i)
        {
            super(s, i);
        }
    }


    private static long INITIALIZE_CONNECTION_TIMEOUT = 0L;
    private static final long MAX_TIMEOUT_FOR_RESTART = 3000L;
    private static final long RESTART_DELAY = 1000L;
    private static final long RESTART_RETRY_SCALAR = 5000L;
    private static long lastRestartedTime = 0L;
    private static int restartDelayExponent = 0;
    private static int restartRetries = 0;
    private static boolean shouldIndicateTreeChanged = true;
    private BleClient bleClient;
    private BluetoothDevice device;
    private final RecoveryTimer mRestartTimer = new RecoveryTimer("GattClientConnection-recovery-timer");
    private final RecoveryTimer mTimer = new RecoveryTimer("GattClientConnection-timeout");
    private BleRequestManager requestManager;
    private Runnable restartBluetoothRunnable;
    private Runnable timeOutRunnable;

    public GattClientConnection()
    {
        timeOutRunnable = new Runnable() {

            final GattClientConnection this$0;

            public void run()
            {
                ALog.d("BluetoothConnection RecoveryTimer tripped", new Object[0]);
                closeConnection();
                startConnection();
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        };
    }

    private void closeConnection()
    {
        ALog.d("BluetoothConnection closeConnection called", new Object[0]);
        mTimer.cancel();
        notifyActionDelayed(new GattClientUpdate(Status.NOT_CONNECTED, null));
        if (requestManager != null)
        {
            requestManager.cancel();
            requestManager.destroy();
            requestManager = null;
        }
        bleClient.cancelDiscoverServices();
        bleClient.cancelEnableCharacteristicNotification();
        bleClient.cancelWriteCharacteristic();
        ReceiveWriteRequests.getInstance().resetCache(getMainHandler());
    }

    public static void postErrorMessageToUser(Context context)
    {
    }

    private void postErrorMessageToUserOrRestart()
    {
label0:
        {
            ALog.d("BluetoothConnection postErrorMessageToUserOrRestart called", new Object[0]);
            if (Math.abs(System.currentTimeMillis() - lastRestartedTime) > 3000L)
            {
                ALog.d("BluetoothConnection actually posting error message", new Object[0]);
                if (restartRetries >= 2)
                {
                    break label0;
                }
                restartRetries++;
                restartDelayExponent++;
                lastRestartedTime = System.currentTimeMillis();
                ALog.d("BluetoothConnection posting restart runnable", new Object[0]);
                mRestartTimer.startOrRestartWithMode((long)(5000D * (Math.pow(2D, restartDelayExponent) - 1.0D)), 1, restartBluetoothRunnable);
            }
            return;
        }
        postErrorMessageToUser(getContext());
    }

    private void startConnection()
    {
        mTimer.startOrRestart(INITIALIZE_CONNECTION_TIMEOUT, timeOutRunnable);
        bleClient.discoverServices().fail(new FailCallback() {

            final GattClientConnection this$0;

            public void onFail(BleDeferredException bledeferredexception)
            {
                postErrorMessageToUserOrRestart();
                BluetoothStatus.setDisconnectReason(-4, "", getContext().getContentResolver()).save(getContext().getContentResolver());
                ALog.e("BluetoothConnection Failed service discovery: ", bledeferredexception, new Object[0]);
            }

            public volatile void onFail(Object obj)
            {
                onFail((BleDeferredException)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).done(new DoneCallback() {

            final GattClientConnection this$0;

            public void onDone(com.olio.bluetooth.ble.promise.BleClient.GattServiceList gattservicelist)
            {
                ALog.d("Successful service discovery", new Object[0]);
                BluetoothGattService bluetoothgattservice;
                for (gattservicelist = gattservicelist.services.iterator(); gattservicelist.hasNext(); ALog.d((new StringBuilder()).append("BluetoothConnection Discovered Service: ").append(bluetoothgattservice.getUuid()).toString(), new Object[0]))
                {
                    bluetoothgattservice = (BluetoothGattService)gattservicelist.next();
                }

            }

            public volatile void onDone(Object obj)
            {
                onDone((com.olio.bluetooth.ble.promise.BleClient.GattServiceList)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).then(new DonePipe() {

            final GattClientConnection this$0;

            public Promise pipeDone(com.olio.bluetooth.ble.promise.BleClient.GattServiceList gattservicelist)
            {
                ALog.d("Calling enableCharacteristicNotification", new Object[0]);
                mTimer.startOrRestart(GattClientConnection.INITIALIZE_CONNECTION_TIMEOUT, timeOutRunnable);
                return bleClient.enableCharacteristicNotification(com.olio.bluetooth.ble.BleDefinedUUIDs.Service.ANCS_SERVICE, com.olio.bluetooth.ble.BleDefinedUUIDs.Characteristic.ANCS_DATA_SOURCE, true, false);
            }

            public volatile Promise pipeDone(Object obj)
            {
                return pipeDone((com.olio.bluetooth.ble.promise.BleClient.GattServiceList)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).done(new DoneCallback() {

            final GattClientConnection this$0;

            public void onDone(BluetoothGattDescriptor bluetoothgattdescriptor)
            {
                ALog.v("BluetoothConnection Successfully registered for the ANCS Data source", new Object[0]);
            }

            public volatile void onDone(Object obj)
            {
                onDone((BluetoothGattDescriptor)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).fail(new FailCallback() {

            final GattClientConnection this$0;

            public void onFail(BleDeferredException bledeferredexception)
            {
                ALog.e("BluetoothConnection Unable to register for the ANCS Data source", bledeferredexception, new Object[0]);
                BluetoothStatus.setDisconnectReason(-3, "data source", getContext().getContentResolver()).save(getContext().getContentResolver());
                postErrorMessageToUserOrRestart();
            }

            public volatile void onFail(Object obj)
            {
                onFail((BleDeferredException)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).then(new DonePipe() {

            final GattClientConnection this$0;

            public Promise pipeDone(BluetoothGattDescriptor bluetoothgattdescriptor)
            {
                mTimer.startOrRestart(GattClientConnection.INITIALIZE_CONNECTION_TIMEOUT, timeOutRunnable);
                return bleClient.enableCharacteristicNotification(com.olio.bluetooth.ble.BleDefinedUUIDs.Service.ANCS_SERVICE, com.olio.bluetooth.ble.BleDefinedUUIDs.Characteristic.ANCS_NOTIFICATION_SOURCE, true, false);
            }

            public volatile Promise pipeDone(Object obj)
            {
                return pipeDone((BluetoothGattDescriptor)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).done(new DoneCallback() {

            final GattClientConnection this$0;

            public void onDone(BluetoothGattDescriptor bluetoothgattdescriptor)
            {
                ALog.v("BluetoothConnection Successfully registered for the ANCS notification source", new Object[0]);
            }

            public volatile void onDone(Object obj)
            {
                onDone((BluetoothGattDescriptor)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).fail(new FailCallback() {

            final GattClientConnection this$0;

            public void onFail(BleDeferredException bledeferredexception)
            {
                ALog.e("BluetoothConnection Unable to register for the ANCS Data source", bledeferredexception, new Object[0]);
                BluetoothStatus.setDisconnectReason(-3, "notification source", getContext().getContentResolver()).save(getContext().getContentResolver());
                postErrorMessageToUserOrRestart();
            }

            public volatile void onFail(Object obj)
            {
                onFail((BleDeferredException)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).then(new DonePipe() {

            final GattClientConnection this$0;

            public Promise pipeDone(BluetoothGattDescriptor bluetoothgattdescriptor)
            {
                mTimer.startOrRestart(GattClientConnection.INITIALIZE_CONNECTION_TIMEOUT, timeOutRunnable);
                return bleClient.enableCharacteristicNotification(com.olio.bluetooth.ble.BleDefinedUUIDs.Service.AMS_SERVICE, com.olio.bluetooth.ble.BleDefinedUUIDs.Characteristic.AMS_ENTITY_UPDATE, true, false);
            }

            public volatile Promise pipeDone(Object obj)
            {
                return pipeDone((BluetoothGattDescriptor)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).done(new DoneCallback() {

            final GattClientConnection this$0;

            public void onDone(BluetoothGattDescriptor bluetoothgattdescriptor)
            {
                ALog.v("BluetoothConnection Successfully registered for the AMS Entity Update source", new Object[0]);
                mTimer.cancel();
            }

            public volatile void onDone(Object obj)
            {
                onDone((BluetoothGattDescriptor)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).fail(new FailCallback() {

            final GattClientConnection this$0;

            public void onFail(BleDeferredException bledeferredexception)
            {
                ALog.e("BluetoothConnection Unable to register for the AMS Entity Update source", bledeferredexception, new Object[0]);
                BluetoothStatus.setDisconnectReason(-3, "AMS Entity Update source", getContext().getContentResolver()).save(getContext().getContentResolver());
                postErrorMessageToUserOrRestart();
                ALog.e("BluetoothConnection RequestManager Fail callback in GattClientConnection", new Object[0]);
                notifyActionDelayed(new GattClientUpdate(Status.NOT_CONNECTED, null));
                closeConnection();
            }

            public volatile void onFail(Object obj)
            {
                onFail((BleDeferredException)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        });
        requestManager = new BleRequestManager();
        requestManager.initialize(bleClient, getContext());
        requestManager.handleRequests(Status.CONNECTING).progress(new ProgressCallback() {

            final GattClientConnection this$0;

            public void onProgress(GattClientUpdate gattclientupdate)
            {
                ALog.d("BluetoothConnection RequestManager: Received a message", new Object[0]);
                static class _cls22
                {

                    static final int $SwitchMap$com$olio$bluetooth$profiles$gatt$GattClientConnection$Status[];

                    static 
                    {
                        $SwitchMap$com$olio$bluetooth$profiles$gatt$GattClientConnection$Status = new int[Status.values().length];
                        try
                        {
                            $SwitchMap$com$olio$bluetooth$profiles$gatt$GattClientConnection$Status[Status.MESSAGE_RECEIVED.ordinal()] = 1;
                        }
                        catch (NoSuchFieldError nosuchfielderror3) { }
                        try
                        {
                            $SwitchMap$com$olio$bluetooth$profiles$gatt$GattClientConnection$Status[Status.CONNECTED.ordinal()] = 2;
                        }
                        catch (NoSuchFieldError nosuchfielderror2) { }
                        try
                        {
                            $SwitchMap$com$olio$bluetooth$profiles$gatt$GattClientConnection$Status[Status.NOT_CONNECTED.ordinal()] = 3;
                        }
                        catch (NoSuchFieldError nosuchfielderror1) { }
                        try
                        {
                            $SwitchMap$com$olio$bluetooth$profiles$gatt$GattClientConnection$Status[Status.CONNECTING.ordinal()] = 4;
                        }
                        catch (NoSuchFieldError nosuchfielderror)
                        {
                            return;
                        }
                    }
                }

                switch (_cls22..SwitchMap.com.olio.bluetooth.profiles.gatt.GattClientConnection.Status[gattclientupdate.status.ordinal()])
                {
                default:
                    return;

                case 1: // '\001'
                    notifyActionDelayed(gattclientupdate);
                    return;

                case 2: // '\002'
                    ALog.d("BluetoothConnection BleRequestManager connected", new Object[0]);
                    notifyActionDelayed(gattclientupdate);
                    RequestManager.enqueueRequest(getContext(), (new MessageBuilder()).setAction(com.olio.communication.messages.Message.Action.DELETE).setDestination("watch").setSource("watch").setPayload((new StreamItemBuilder()).setDateCreated(Calendar.getInstance().getTime()).setNotificationId("BLE-CONNECTION-ERROR").build()).build());
                    GattClientConnection.restartRetries = 0;
                    GattClientConnection.restartDelayExponent = 0;
                    mRestartTimer.cancel();
                    return;

                case 3: // '\003'
                    ALog.d("BluetoothConnection BleRequestManager disconnected", new Object[0]);
                    notifyActionDelayed(gattclientupdate);
                    GattClientConnection.postErrorMessageToUser(getContext());
                    return;

                case 4: // '\004'
                    ALog.d("BluetoothConnection BleRequestManager connecting", new Object[0]);
                    break;
                }
                notifyActionDelayed(gattclientupdate);
            }

            public volatile void onProgress(Object obj)
            {
                onProgress((GattClientUpdate)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).done(new DoneCallback() {

            final GattClientConnection this$0;

            public volatile void onDone(Object obj)
            {
                onDone((Void)obj);
            }

            public void onDone(Void void1)
            {
                ALog.d("BluetoothConnection Finished receiving messages", new Object[0]);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).fail(new FailCallback() {

            final GattClientConnection this$0;

            public void onFail(BleDeferredException bledeferredexception)
            {
                ALog.e("BluetoothConnection RequestManager Fail callback in GattClientConnection", new Object[0]);
                ALog.e("BluetoothConnection Failed receiving messages. probably cancellation", bledeferredexception, new Object[0]);
                if (bledeferredexception.exceptionData != null && bledeferredexception.exceptionReason != null && bledeferredexception.exceptionReason != com.olio.bluetooth.ble.promise.BleDeferredException.ExceptionReason.Cancelled)
                {
                    BluetoothStatus.setDisconnectReason(bledeferredexception.exceptionData.arg1(), bledeferredexception.exceptionReason.toString(), getContext().getContentResolver()).save(getContext().getContentResolver());
                } else
                if (bledeferredexception.exceptionData == null && bledeferredexception.exceptionReason != null && bledeferredexception.exceptionReason != com.olio.bluetooth.ble.promise.BleDeferredException.ExceptionReason.Cancelled)
                {
                    BluetoothStatus.setDisconnectReason(-1, bledeferredexception.exceptionReason.toString(), getContext().getContentResolver()).save(getContext().getContentResolver());
                    return;
                }
            }

            public volatile void onFail(Object obj)
            {
                onFail((BleDeferredException)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).always(new AlwaysCallback() {

            final GattClientConnection this$0;

            public volatile void onAlways(org.jdeferred.Promise.State state, Object obj, Object obj1)
            {
                onAlways(state, (Void)obj, (BleDeferredException)obj1);
            }

            public void onAlways(org.jdeferred.Promise.State state, Void void1, BleDeferredException bledeferredexception)
            {
                notifyActionDelayed(new GattClientUpdate(Status.NOT_CONNECTED, null));
                closeConnection();
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        });
    }

    protected void additionalPromise(Deferred deferred, Promise promise, BluetoothDevice bluetoothdevice)
    {
        ALog.d((new StringBuilder()).append("BluetoothConnection GattClientConnection: Attempting to connectGattClient with device: ").append(bluetoothdevice.getName()).append(" address: ").append(bluetoothdevice.getAddress()).toString(), new Object[0]);
        device = bluetoothdevice;
        notifyActionDelayed(new GattClientUpdate(Status.CONNECTING, null));
        bleClient.connect(bluetoothdevice, true).progress(new ProgressCallback() {

            private int currentState;
            final GattClientConnection this$0;

            public void onProgress(com.olio.bluetooth.ble.promise.BleClient.DeviceGattStatus devicegattstatus)
            {
                if (devicegattstatus.state != currentState) goto _L2; else goto _L1
_L1:
                return;
_L2:
                currentState = devicegattstatus.state;
                switch (devicegattstatus.state)
                {
                case 1: // '\001'
                default:
                    return;

                case 0: // '\0'
                    ALog.d("BluetoothConnection GattClientConnection: disconnect address: %s, isEnabled: %b", new Object[] {
                        devicegattstatus.device.getAddress(), Boolean.valueOf(BluetoothAdapter.getDefaultAdapter().isEnabled())
                    });
                    closeConnection();
                    if (BluetoothAdapter.getDefaultAdapter().isEnabled())
                    {
                        GattClientConnection.restartRetries = 0;
                        return;
                    }
                    break;

                case 2: // '\002'
                    ALog.d((new StringBuilder()).append("BluetoothConnection GattClientConnection: connect address: ").append(devicegattstatus.device.getAddress()).toString(), new Object[0]);
                    startConnection();
                    return;
                }
                if (true) goto _L1; else goto _L3
_L3:
            }

            public volatile void onProgress(Object obj)
            {
                onProgress((com.olio.bluetooth.ble.promise.BleClient.DeviceGattStatus)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
                currentState = 0;
            }
        }).fail(new FailCallback() {

            final GattClientConnection this$0;

            public void onFail(BleDeferredException bledeferredexception)
            {
                ALog.d("BluetoothConnection BleDeferredException GattClientConnection fail", new Object[0]);
            }

            public volatile void onFail(Object obj)
            {
                onFail((BleDeferredException)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).done(new DoneCallback() {

            final GattClientConnection this$0;

            public void onDone(com.olio.bluetooth.ble.promise.BleClient.DeviceGattStatus devicegattstatus)
            {
                ALog.d("BluetoothConnection BleDeferredException GattClientConnection done", new Object[0]);
            }

            public volatile void onDone(Object obj)
            {
                onDone((com.olio.bluetooth.ble.promise.BleClient.DeviceGattStatus)obj);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        }).always(new AlwaysCallback() {

            final GattClientConnection this$0;

            public void onAlways(org.jdeferred.Promise.State state, com.olio.bluetooth.ble.promise.BleClient.DeviceGattStatus devicegattstatus, BleDeferredException bledeferredexception)
            {
                mTimer.cancel();
                if (requestManager != null)
                {
                    requestManager.destroy();
                    requestManager = null;
                }
            }

            public volatile void onAlways(org.jdeferred.Promise.State state, Object obj, Object obj1)
            {
                onAlways(state, (com.olio.bluetooth.ble.promise.BleClient.DeviceGattStatus)obj, (BleDeferredException)obj1);
            }

            
            {
                this$0 = GattClientConnection.this;
                super();
            }
        });
    }

    protected volatile void additionalPromise(Deferred deferred, Promise promise, Object obj)
    {
        additionalPromise(deferred, promise, (BluetoothDevice)obj);
    }

    protected PromiseException calledTwiceRejection()
    {
        return new PromiseException("BluetoothConnection Called Twice", com.olio.bluetooth.ble.promise.framework.PromiseException.Failure.DOUBLE_REGISTER);
    }

    protected volatile Object calledTwiceRejection()
    {
        return calledTwiceRejection();
    }

    protected PromiseException cancelledError()
    {
        return new PromiseException("BluetoothConnection Cancelled Error", com.olio.bluetooth.ble.promise.framework.PromiseException.Failure.CANCEL);
    }

    protected volatile Object cancelledError()
    {
        return cancelledError();
    }

    public void initialize(final Context context)
    {
        ALog.d("BluetoothConnection GattClientConnection: Initialize", new Object[0]);
        if (isInitialized())
        {
            throw new RuntimeException("BluetoothConnection Tried initializing GattClientConnection twice");
        } else
        {
            super.initialize(context);
            bleClient = new BleClient();
            bleClient.initialize(context, new Handler(context.getMainLooper()));
            mTimer.init(context, getMainHandler());
            mRestartTimer.init(context, getMainHandler());
            restartBluetoothRunnable = new Runnable() {

                final GattClientConnection this$0;
                final Context val$context;

                public void run()
                {
                    ALog.e("BluetoothConnection Restart runnable called", new Object[0]);
                    PowerCycle.powerCycleBluetooth(context);
                }

            
            {
                this$0 = GattClientConnection.this;
                context = context1;
                super();
            }
            };
            return;
        }
    }

    protected void onReject()
    {
        uninitialize();
    }

    protected void onResolve()
    {
        uninitialize();
    }

    public boolean reconnect()
    {
        if (bleClient != null && isPending())
        {
            return bleClient.reconnect();
        } else
        {
            return false;
        }
    }

    public void uninitialize()
    {
        ALog.d("BluetoothConnection GattClientConnection: UnInitialize", new Object[0]);
        super.uninitialize();
        if (bleClient != null)
        {
            bleClient.destroy();
            bleClient = null;
        }
        mTimer.dispose();
        mRestartTimer.dispose();
    }

    static 
    {
        INITIALIZE_CONNECTION_TIMEOUT = 0x36ee80L;
    }





/*
    static int access$1102(int i)
    {
        restartRetries = i;
        return i;
    }

*/


/*
    static int access$1202(int i)
    {
        restartDelayExponent = i;
        return i;
    }

*/






/*
    static BleRequestManager access$1602(GattClientConnection gattclientconnection, BleRequestManager blerequestmanager)
    {
        gattclientconnection.requestManager = blerequestmanager;
        return blerequestmanager;
    }

*/








}
